VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Keys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_lpObjCollection As Long
Private m_nCurrentEnumRef As Long

Implements IEnumVReDef.IEnumVARIANTReDef
Implements IReadOnlyCollection
Implements IEnumerator
Implements ICollection

Private Sub ICollection_Add(Item As Variant)
    Call Err.Raise(vbObjectError, , "NotSupportedException")
End Sub

Private Sub ICollection_Clear()
    Call Err.Raise(vbObjectError, , "NotSupportedException")
End Sub

Private Function ICollection_Contains(Item As Variant) As Boolean
    Call Err.Raise(vbObjectError, , "NotSupportedException")
End Function

Private Property Get ICollection_Count() As Long
    ICollection_Count = Count
End Property

Private Function ICollection_GetEnumerator() As XDSystemLib.IEnumerator
    Set ICollection_GetEnumerator = NewEnum
End Function

Private Property Get ICollection_IsReadOnly() As Boolean
    ICollection_IsReadOnly = True
End Property

Private Function ICollection_Remove(Value As Variant) As Boolean
    Call Err.Raise(vbObjectError, , "NotSupportedException")
End Function

Private Sub ICollection_CopyTo(ArrayTo As Variant, Optional ByVal Index As Long)
    Dim KeyCount As Long
    Dim i As Long
    
    If MIEnumVARIANT.IsCollectionPointerValid(m_lpObjCollection) > (-1) Then
        With MIEnumVARIANT.ResolveCollectionPointer(m_lpObjCollection)
            KeyCount = .GetKeysCount
            
            If KeyCount = 0 Then
                If Index = 0 Then
                    Call InvalidateArray(ArrayTo)
                End If
            
                Exit Sub
            End If
            
            If SafeUBound(ArrayTo) < KeyCount - 1 Then
                ReDim ArrayTo(KeyCount - 1)
            End If
            
            If Index = 0 Then
                Index = KeyCount - 1
            End If
            
            For i = 0 To Index
                ArrayTo(i) = .Key(i + 1).Name
            Next
        End With
    End If
End Sub

Private Sub IEnumerator_Reset()
    Call IEnumVARIANTReDef_Reset
End Sub

'Functions
Private Function IEnumerator_MoveNext() As Boolean
    If m_nCurrentEnumRef < Count Then
        IEnumerator_MoveNext = True
    End If
End Function

'Properties
Private Property Get IEnumerator_Current() As Variant
    Call IEnumVARIANTReDef_GetItems(0, IEnumerator_Current, 0, 0)
End Property

Public Property Get NewEnum() As IEnumerator
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    ' this property allows you to enumerate the collection with the For...Each syntax
    
    Dim oIev As IEnumVARIANTReDef
    Set oIev = Me
    
    ' replace the vtable entry for the Next function on the IEnumVARIANTReDef interface
    MIEnumVARIANT.ReplaceVtableEntry ObjPtr(oIev), 4, AddressOf MIEnumVARIANT.IEnumVARIANT_Next
      
    Set NewEnum = oIev
    
    Set oIev = Nothing
End Property

Public Property Get Count() As Long
    ' call back into the collection to get the count of the keys array
    
    If MIEnumVARIANT.IsCollectionPointerValid(m_lpObjCollection) > (-1) Then
        Count = MIEnumVARIANT.ResolveCollectionPointer(m_lpObjCollection).GetKeysCount()
    End If
End Property

Public Property Get Item(ByVal Index As Long) As Key
Attribute Item.VB_UserMemId = 0
    If MIEnumVARIANT.IsCollectionPointerValid(m_lpObjCollection) > (-1) Then
        Set Item = MIEnumVARIANT.ResolveCollectionPointer(m_lpObjCollection).Key(Index)
    End If
End Property

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = Me.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.NewEnum
End Function

Private Sub IEnumVARIANTReDef_Clone(lppIEnum As IEnumVReDef.IEnumVARIANTReDef)
    ' from the Win32 SDK:
    ' Using this function, a particular point in the enumeration sequence can
    ' be recorded, and then returned to at a later time. The returned enumerator
    ' is of the same actual interface as the one that is being cloned.
    '
    ' you would be hard pressed to find a way to use this in VB but it wasn't
    ' difficult to implement
    Dim oKeys As Keys
    
    Set oKeys = New Keys
    
    oKeys.InitializeForEnumeration m_lpObjCollection, m_nCurrentEnumRef
    
    Set lppIEnum = oKeys
    
    Set oKeys = Nothing
End Sub

Private Sub IEnumVARIANTReDef_GetItems(ByVal cElements As Long, aVariants As Variant, ByVal lpcElementsFetched As Long, lRetVal As Long)
    ' this method is called from the function IEnumVARIANT_Next in the MIEnumVARIANT bas module.
    ' it is an addition to the IEnumVARIANT interface provided in the 'ienumv.tlb' typelib.  this
    ' method provides a backdoor into this class via the 'this' pointer passed to IEnumVARIANT_Next by COM.
    ' in this way, the data in this class can be accessed from the IEnumVARIANT_Next function without jumping
    ' through hoops and creating circular references.  only the aVariants and lRetVal parameters are used in
    ' this implimentation.
    
    If MIEnumVARIANT.IsCollectionPointerValid(m_lpObjCollection) > (-1) Then
          MIEnumVARIANT.ResolveCollectionPointer(m_lpObjCollection).GetKeysForEnumeration m_nCurrentEnumRef, aVariants, lRetVal
        
          ' don't forget to increment the counter (passed ByRef from the Keys object)
          m_nCurrentEnumRef = m_nCurrentEnumRef + 1
    Else
        lRetVal = S_FALSE
    End If
End Sub

Private Sub IEnumVARIANTReDef_Next(ByVal cElements As Long, aVariants As Variant, ByVal lpcElementsFetched As Long)
    ' This function is delegated to the IEnumVARIANT_Next function in our MIEnumVARIANT bas module.
    ' Right before the actual enumeration begins, we alter the vtable of this object so that it
    ' points to the address of the IEnumVARIANT_Next function in the bas module
End Sub

Private Sub IEnumVARIANTReDef_Reset()
    m_nCurrentEnumRef = 0
End Sub

Private Sub IEnumVARIANTReDef_Skip(ByVal cElements As Long)
    ' increment the enum counter the specified number of elements to skip
    m_nCurrentEnumRef = m_nCurrentEnumRef + cElements
End Sub

Friend Function InitializeForEnumeration(ByVal lpObject&, ByVal nEnumPointer&) As Boolean
    ' this function is called when this object is created.
    ' pass in the pointer to the parent collection object and the place to start the enumeration
    
    m_lpObjCollection = lpObject
    
    m_nCurrentEnumRef = nEnumPointer
End Function
