Attribute VB_Name = "MiscFunctions"
Option Explicit

Private Declare Sub RtlMoveMemory Lib "kernel32" (pDest As Any, pSource As Any, Optional ByVal ByteLen As Long = 4)
Private Const VT_BYREF As Long = &H4000&
Private Const FADF_FIXEDSIZE As Long = &H10  '16

Public Sub SwapArrayPtr(ByRef arrayTo As Variant, ByRef ArrayFrom As Variant)
    Dim FlagFrom As Integer
    Dim FlagTo As Integer
    
    Dim MemVarFrom As Long
    Dim MemVarTo As Long
  
    Call RtlMoveMemory(FlagTo, arrayTo, 2)
    Call RtlMoveMemory(FlagFrom, ArrayFrom, 2)
    
    If (FlagTo And vbArray) = 0 And FlagTo <> vbEmpty And (FlagTo And VT_BYREF) > 0 Then
        Call MsgBox("ArrayTo points to a existing non-array " & TypeName(arrayTo) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    ElseIf (FlagFrom And vbArray) = 0 And FlagFrom <> vbEmpty And (FlagFrom And VT_BYREF) > 0 Then
        Call MsgBox("ArrayFrom points to a existing non-array " & TypeName(ArrayFrom) & " variable " _
            & " and therefore it should not be swapped", vbInformation, "This should not be done")
    ElseIf IsEmpty(arrayTo) Xor IsEmpty(ArrayFrom) Then
        If IsEmpty(arrayTo) Then
            If VarType(ArrayFrom) And Not vbArray = vbUserDefinedType Then
                arrayTo = ArrayFrom

                Call InitArray(ArrayFrom, True)
     
                Exit Sub
            End If
        
            If (FlagFrom And VT_BYREF) = 0 Then
                MemVarFrom = VarPtr(ArrayFrom) + 8
            Else
                Call RtlMoveMemory(MemVarFrom, ByVal VarPtr(ArrayFrom) + 8, 4)
            End If
 
            Call RtlMoveMemory(ByVal VarPtr(arrayTo) + 8, ByVal MemVarFrom, 4)
            Call RtlMoveMemory(arrayTo, VarType(ArrayFrom), 2)

            Call RtlMoveMemory(ByVal MemVarFrom, 0&, 4) 'bei UDT-array absturz
        Else
            Call SwapArrayPtr(ArrayFrom, arrayTo) 'Rekursion mit vertauschten parametern
        End If

        Exit Sub
    ElseIf IsEmpty(ArrayFrom) And IsEmpty(ArrayFrom) Then
        Exit Sub
    Else
        If (FlagFrom And VT_BYREF) = 0 Then
            MemVarFrom = VarPtr(ArrayFrom) + 8
        Else
            Call RtlMoveMemory(MemVarFrom, ByVal VarPtr(ArrayFrom) + 8, 4)
        End If
        
        If (FlagTo And VT_BYREF) = 0 Then
            MemVarTo = VarPtr(arrayTo) + 8
        Else
            Call RtlMoveMemory(MemVarTo, ByVal VarPtr(arrayTo) + 8, 4)
        End If
        
        Dim Temp As Long
        
        Call RtlMoveMemory(Temp, ByVal MemVarFrom, 4)
        Call RtlMoveMemory(ByVal MemVarFrom, ByVal MemVarTo, 4)
        Call RtlMoveMemory(ByVal MemVarTo, Temp, 4)
        
        If VarType(ArrayFrom) <> VarType(arrayTo) Then
            If (FlagTo And VT_BYREF) = 0 Then
                Call RtlMoveMemory(arrayTo, ArrayFrom, 1)
            ElseIf (FlagFrom And VT_BYREF) = 0 Then
                Call RtlMoveMemory(ArrayFrom, arrayTo, 1)
            End If
        End If
    End If
End Sub

Private Function InitArray(ByRef Arr As Variant, Optional ByVal SafeErase As Boolean) As Boolean
    Dim Ptr As Long
    Dim Typ As Integer
    Dim Dimensions As Integer
    Dim Flags As Integer
    Dim boolUninitialised As Boolean
    
    If IsArray(Arr) Then
        Do
            Call RtlMoveMemory(Typ, ByVal VarPtr(Arr), 2)
            Call RtlMoveMemory(Ptr, ByVal VarPtr(Arr) + 8)
            
            If (Typ And VT_BYREF) <> 0 Then
                Call RtlMoveMemory(Ptr, ByVal Ptr)
            End If
            
            If Ptr = 0 Then
                boolUninitialised = True
                ReDim Arr(0)
            End If
        Loop Until Ptr <> 0
        
        Call RtlMoveMemory(Dimensions, ByVal Ptr, 2)
        Call RtlMoveMemory(Flags, ByVal Ptr + 2, 2)

        If (Flags And FADF_FIXEDSIZE) = 0 And (boolUninitialised Or SafeErase) Then
            If boolUninitialised = False Then
                Select Case Dimensions
                    Case 1
                        ReDim Arr(0)
                    Case 2
                        ReDim Arr(0, 0)
                    Case Else
                        Exit Function
                End Select
                
                Call RtlMoveMemory(Ptr, ByVal VarPtr(Arr) + 8)
                
                If (Typ And VT_BYREF) <> 0 Then
                    Call RtlMoveMemory(Ptr, ByVal Ptr)
                End If
            End If
            
            Call RtlMoveMemory(ByVal Ptr + 16, 0&)
            
            InitArray = UBound(Arr) = -1
        End If
    End If
End Function

Public Function GetObjFromPtr(ByVal Ptr As Long) As Object
    Dim nObj As Object
    
    If Ptr <> 0 Then
        Call RtlMoveMemory(nObj, Ptr, 4)
        
        Set GetObjFromPtr = nObj
        
        Call RtlMoveMemory(nObj, 0&, 4)
    End If
End Function

Public Sub SwapVar(ByRef VarA As Variant, ByRef VarB As Variant)
    Dim X(0 To 15) As Byte
    
    Call RtlMoveMemory(X(0), VarA, 16)
    Call RtlMoveMemory(VarA, VarB, 16)
    Call RtlMoveMemory(VarB, X(0), 16)
End Sub
