VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Directory"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum SearchOption
    TopDirectoryOnly
    AllDirectories
End Enum

Public Function DirectoryExists(ByVal DirectoryPath As String) As Boolean
    DirectoryExists = Len(Dir(DirectoryPath, vbDirectory)) > 0
End Function

Public Function CreateDirectory(ByRef Path As String, Optional ByVal RaiseError As Boolean = True) As Boolean
    CreateDirectory = ApiCreateDirectoryPath(Path, RaiseError)
End Function

Public Function DeleteDirectory(ByVal Path As String, Optional ByVal Recursive As Boolean) As Boolean
    If Recursive Then
        Call Err.Raise(vbObjectError, , "Recursive not yet implemented")
    End If

    DeleteDirectory = ApiKillDirectory(Path)
End Function

Public Function CopyDirectory( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal FileExtensionsPattern As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal Recursive As Boolean, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    CopyDirectory = ApiCopyFileEx(SourcePath, TargetPath, FileExtensionsPattern, OverwriteFiles, Recursive, OnlyIfNewer, RaiseError)
End Function

Public Function GetFiles( _
        ByVal Path As String, _
        Optional ByVal FileExtensionsPattern As Variant, _
        Optional ByVal SearchOption As SearchOption _
        ) As String()
    If SearchOption = AllDirectories Then
        Call Err.Raise(vbObjectError, , "SearchOption is currently not supported")
    End If
        
    GetFiles = mdlString.ApiFindFilesOrFolders(Path, FileExtensionsPattern, False)
End Function

Public Function GetDirectories( _
        ByVal Path As String, _
        Optional ByVal SearchPattern As Variant, _
        Optional ByVal SearchOption As SearchOption _
        ) As String()
    If IsMissingNullOrEmpty(SearchPattern) = False Or SearchOption = AllDirectories Then
        Call Err.Raise(vbObjectError, , "SearchPattern and SearchOption are currently not supported")
    End If
        
    GetDirectories = mdlString.ApiFindFilesOrFolders(Path, , True)
End Function
