VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Files"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum SpecialFolder
    CSIDL_ADMINTOOLS = &H30
    CSIDL_ALTSTARTUP = &H1D
    CSIDL_APPDATA = &H1A
    CSIDL_BITBUCKET = &HA
    CSIDL_QUICKLAUNCH = 9999
    CSIDL_COMMON_ADMINTOOLS = &H2F
    CSIDL_COMMON_ALTSTARTUP = &H1E
    CSIDL_COMMON_APPDATA = &H23
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19
    CSIDL_COMMON_DOCUMENTS = &H2E
    CSIDL_COMMON_FAVORITES = &H1F
    CSIDL_COMMON_PROGRAMS = &H17
    CSIDL_COMMON_STARTMENU = &H16
    CSIDL_COMMON_STARTUP = &H18
    CSIDL_COMMON_TEMPLATES = &H2D
    CSIDL_CONNECTIONS = &H31
    CSIDL_CONTROLS = &H3
    CSIDL_COOKIES = &H21
    CSIDL_DESKTOP = &H0
    CSIDL_DESKTOPDIRECTORY = &H10
    CSIDL_DRIVES = &H11
    CSIDL_FAVORITES = &H6
    CSIDL_FLAG_CREATE = &H8000
    CSIDL_FLAG_DONT_VERIFY = &H4000
    CSIDL_FLAG_MASK = &HFF00
    CSIDL_FLAG_PFTI_TRACKTARGET = CSIDL_FLAG_DONT_VERIFY
    CSIDL_FONTS = &H14
    CSIDL_HISTORY = &H22
    CSIDL_INTERNET = &H1
    CSIDL_INTERNET_CACHE = &H20
    CSIDL_LOCAL_APPDATA = &H1C
    CSIDL_MYPICTURES = &H27
    CSIDL_NETHOOD = &H13
    CSIDL_NETWORK = &H12
    CSIDL_PERSONAL = &H5
    CSIDL_PRINTERS = &H4
    CSIDL_PRINTHOOD = &H1B
    CSIDL_PROFILE = &H28
    CSIDL_PROGRAM_FILES = &H26
    CSIDL_PROGRAM_FILES_COMMON = &H2B 'Gemeinsame Dateien
    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C
    CSIDL_PROGRAM_FILESX86 = &H2A
    CSIDL_PROGRAMS = &H2
    CSIDL_RECENT = &H8
    CSIDL_SENDTO = &H9
    CSIDL_STARTMENU = &HB
    CSIDL_STARTUP = &H7
    CSIDL_SYSTEM = &H25
    CSIDL_SYSTEMX86 = &H29
    CSIDL_TEMPLATES = &H15
    CSIDL_WINDOWS = &H24
End Enum

Public Type FILE_VERSION
    FileName As String
    FileType As String
    FileVersion As String
    FilePath As String
    WindowsVersion As String
    StructureVersion As String
    ProductVersion As String
    Flags As String
    DateCreated As Date
    DateChanged As Date
End Type

Public Type FILE_DATE
    DateCreated As Date
    DateChanged As Date
    DateLastAccess As Date
End Type

Public Enum ShellExecuteError
     SE_ERR_FNF = 2&
     SE_ERR_PNF = 3&
     SE_ERR_ACCESSDENIED = 5&
     SE_ERR_OOM = 8&
     SE_ERR_DLLNOTFOUND = 32&
     SE_ERR_SHARE = 26&
     SE_ERR_ASSOCINCOMPLETE = 27&
     SE_ERR_DDETIMEOUT = 28&
     SE_ERR_DDEFAIL = 29&
     SE_ERR_DDEBUSY = 30&
     SE_ERR_NOASSOC = 31&
     ERROR_BAD_FORMAT = 11&
End Enum

Public Enum ShellExecuteAction
    OpenFile
    MailTo
    PrintFile
    Explorer
End Enum

Private Declare Function ShellExecute_Api Lib "shell32.dll" Alias "ShellExecuteA" ( _
     ByVal hwnd As Long, _
     ByVal lpOperation As String, _
     ByVal lpFile As String, _
     ByVal lpParameters As String, _
     ByVal lpDirectory As String, _
     ByVal nShowCmd As Long) As ShellExecuteError

Public Function ShellExecute( _
        ByVal FilePath As String, _
        Optional ByVal Parameters As String, _
        Optional ByVal Directory As String, _
        Optional ByVal AppWinStyle As VbAppWinStyle = vbNormalFocus, _
        Optional ByVal Mode As ShellExecuteAction = ShellExecuteAction.OpenFile, _
        Optional ByVal ParentHwnd As Long _
        ) As ShellExecuteError
    Dim strModus As String
    Const SW_RESTORE As Long = &H9&
    
    Select Case Mode
        Case ShellExecuteAction.OpenFile
            strModus = "open"
        Case ShellExecuteAction.MailTo
            strModus = "open"
            FilePath = "mailto:" & FilePath
        Case ShellExecuteAction.PrintFile
            strModus = "print"
            AppWinStyle = vbNormalFocus
        Case ShellExecuteAction.Explorer
            strModus = "explore"
            AppWinStyle = SW_RESTORE
    End Select
    
    ShellExecute = ShellExecute_Api(ParentHwnd, strModus, FilePath, Parameters, Directory, AppWinStyle)
End Function

Public Function GetFileDate(ByVal FilePath As String) As FILE_DATE
    GetFileDate = mdlVersion.ApiGetFileDate(FilePath)
End Function

Public Function CreateShortcut( _
        ByVal FileName As String, _
        ByVal ShortcutName As String, _
        Optional ByVal Folder As SpecialFolder = SpecialFolder.CSIDL_DESKTOP, _
        Optional ByVal Description As String, _
        Optional ByVal Hotkey As String, _
        Optional ByVal Overwrite As Boolean) As Boolean
    CreateShortcut = mdlFunctions.CreateShortcut(FileName, ShortcutName, Folder, Description, Hotkey, Overwrite)
End Function

Public Function GetFileVersionInfoStrings(ByVal FileName As String, InfoStrings As Variant) As String()
    GetFileVersionInfoStrings = mdlVersion.GetVersionInfoStrings(FileName, InfoStrings)
End Function

Public Function GetFileVersionInformation(ByVal FilePath As String) As FILE_VERSION
    GetFileVersionInformation = mdlVersion.ApiGetFileVersionInformation(FilePath)
End Function

Public Function GetDirectorySize(ByVal DirectoryPath As String, Optional ByVal OnlyTheseExtensions As String) As Currency
    GetDirectorySize = ApiGetDirectorySize(DirectoryPath, OnlyTheseExtensions)
End Function

Public Function RecycleFile(ByRef FilePath As String) As Long
    RecycleFile = mdlIO.RecycleFile(FilePath)
End Function

Public Function SetEof(ByRef FileName As String, ByVal EOF As Currency) As Boolean
    SetEof = mdlIO.SetEof(FileName, EOF)
End Function

Public Function GetFileAccess(ByVal FilePath As String, Optional ByVal ReadOnly As Boolean) As Boolean
    GetFileAccess = mdlIO.CanGetExclusiveAccess(FilePath, ReadOnly)
End Function

Public Sub KillFiles( _
        ByVal FilePath As String, _
        Optional ByVal Files As String = "*", _
        Optional ByVal DontDeleteFileswithTheseExtensions As String _
        )
    Call mdlIO.KillFiles(FilePath, Files, DontDeleteFileswithTheseExtensions)
End Sub

Public Function KillDirectory(ByVal Path As String) As Boolean
    KillDirectory = ApiKillDirectory(Path)
End Function

Public Function IsFileOpened(ByVal FilePath As String) As Boolean
    IsFileOpened = ApiIsFileAlreadyOpen(FilePath)
End Function

Public Function CopyFiles( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal CopyTheseFileExtensions As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal IncludeSubDirs As Boolean, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    CopyFiles = ApiCopyFileEx(SourcePath, TargetPath, CopyTheseFileExtensions, OverwriteFiles, IncludeSubDirs, OnlyIfNewer, RaiseError)
End Function

Public Function MoveFiles( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal CopyTheseFileExtensions As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal IncludeSubDirs As Boolean, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    MoveFiles = ApiCopyFileEx(SourcePath, TargetPath, CopyTheseFileExtensions, OverwriteFiles, IncludeSubDirs, OnlyIfNewer, RaiseError, True)
End Function

Public Function CopyFile( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    CopyFile = ApiCopyFile(SourcePath, TargetPath, OverwriteFiles, OnlyIfNewer, RaiseError)
End Function

Public Function MoveFile( _
        ByVal SourcePath As String, _
        ByVal TargetPath As String, _
        Optional ByVal OverwriteFiles As Boolean = True, _
        Optional ByVal OnlyIfNewer As Boolean, _
        Optional ByVal RaiseError As Boolean _
        ) As Boolean
    MoveFile = ApiCopyFile(SourcePath, TargetPath, OverwriteFiles, OnlyIfNewer, RaiseError, True)
End Function

Public Function GetFileString(ByVal FilePath As String) As String
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Binary As #f
        GetFileString = Input$(LOF(f), #f)
    Close #f
End Function

Public Sub SetFileString(ByVal FilePath As String, ByRef FileString As String)
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Output As #f
        Print #f, FileString
    Close #f
End Sub

Public Sub SetFileBytes(ByVal FilePath As String, ByRef FileBytes() As Byte)
    Dim f As Integer
    
    f = FreeFile
    
    Open FilePath For Binary As #f
        Put #f, 1, FileBytes
    Close #f
End Sub

Public Function GetFileBytes(ByVal FilePath As String) As Byte()
    GetFileBytes = mdlFunctions.GetFileBytes(FilePath, , True)
End Function

Public Function GetFileBytesEx(ByVal FilePath As String, Optional ByRef Content As String) As Byte()
    GetFileBytesEx = mdlFunctions.GetFileBytes(FilePath, Content)
End Function

Public Function GetFileSize(ByVal FilePath As String) As Currency
    GetFileSize = ApiGetFileSize(FilePath)
End Function

Public Function GetFileTitle(ByVal FilePath As String) As String
    GetFileTitle = ApiFileTitle(FilePath)
End Function

Public Function FileExists(ByVal FilePath As String) As Boolean
    FileExists = mdlIO.SafeFileExists(FilePath)
End Function

Public Function FileExistsEx(ByVal FilePath As String, Optional ByVal AllowedFileExtensions As String) As Boolean
    FileExistsEx = mdlIO.ApiFileExists(FilePath, AllowedFileExtensions)
End Function

Public Sub KillFile(ByVal FilePath As String, Optional ByVal AllowedFileExtensions As String, Optional ByVal TheseFilesNot As String)
    Call mdlIO.ApiKillFile(FilePath, AllowedFileExtensions, TheseFilesNot)
End Sub

