VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Information"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Constants
Private Const MAX_MESSAGE_LENGTH As Long = 1024

Private Const FORMAT_MESSAGE_FROM_SYSTEM    As Long = &H1000&
Private Const FORMAT_MESSAGE_IGNORE_INSERTS As Long = &H200&
Private Const FORMAT_MESSAGE_MAX_WIDTH_MASK As Long = &HFF&
Private Const LANG_USER_DEFAULT             As Long = &H400&

'API declarations
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" ( _
        ByVal dwFlags As Long, _
        lpSource As Any, _
        ByVal dwMessageId As Long, _
        ByVal dwLanguageId As Long, _
        ByVal lpBuffer As String, _
        ByVal nSize As Long, _
        Arguments As Long) As Long
        
Private Declare Function SHAppBarMessage Lib "shell32.dll" (ByVal dwMessage As Long, pData As APPBARDATA) As Long

Private Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type APPBARDATA
    cbSize As Long
    hwnd As Long
    uCallBackMessage As Long
    uEdge As Long
    rc As Rect
    lParam As Long
End Type

Public Function TaskbarHeight() As Long
    Dim abdTaskBarPos As APPBARDATA
    Const ABM_GETTASKBARPOS As Long = &H5&
    
    Call SHAppBarMessage(ABM_GETTASKBARPOS, abdTaskBarPos)
    
    TaskbarHeight = (abdTaskBarPos.rc.Bottom - abdTaskBarPos.rc.Top)
End Function

Public Function GetAPIErrorDesc(ByVal ErrNumber As Long) As String
    Dim sBuffer    As String * MAX_MESSAGE_LENGTH 'declare message buffer
    Dim lBufferLen As Long    ' Lnge des reservierten Strings
    
    ' Stringbuffer fr die Rckgabe reservieren
    ' Fehlernummer in einen Fehlertext wandeln
    lBufferLen = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM _
            Or FORMAT_MESSAGE_MAX_WIDTH_MASK _
            Or FORMAT_MESSAGE_IGNORE_INSERTS, _
            ByVal 0&, ErrNumber, _
            LANG_USER_DEFAULT, _
            sBuffer, Len(sBuffer), 0)
            
    If lBufferLen > 0 Then
        ' Fehler wurde identifiziert, der Fehlertext liegt vor
        GetAPIErrorDesc = Left$(sBuffer, lBufferLen)
    Else
        ' Der Fehlertext konnte nicht ermittelt werden
        GetAPIErrorDesc = "Unbekannter Fehler: &H" & Hex$(ErrNumber)
    End If
End Function

Public Function IsIDERunning() As Boolean
    IsIDERunning = boolVBIDE
End Function

Public Function SizeOf(ByRef var As Variant) As Long
    SizeOf = mdlFunctions.SizeOf(var)
End Function

Public Function IsUniCode(ByRef Text As String) As Boolean
    If Len(Text) > 0 Then
        If AscB(MidB(Text, 2, 1)) = 0 Then
            IsUniCode = True
        End If
    End If
End Function

Public Function GetTextMeasures(ByVal hDC As Long, ByRef Text As String, Optional ByVal GetHeight As Boolean) As Long
    GetTextMeasures = ApiGetTextMeasures(hDC, Text, GetHeight)
End Function

Public Function ScreenWidth() As Long
    ScreenWidth = Screen.Width \ Screen.TwipsPerPixelX
End Function

Public Function ScreenHeight() As Long
    ScreenHeight = Screen.Height \ Screen.TwipsPerPixelY
End Function


