VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Path"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Public Function CombinePath(ByVal Path1 As String, ByVal Path2 As String) As String
'    CombinePath = mdlString.ApiAddSlash(Path1, , True) & Path2
'End Function

Private Declare Function ExpandEnvironmentStrings _
   Lib "kernel32" Alias "ExpandEnvironmentStringsA" _
   (ByVal lpSrc As String, ByVal lpDst As String, _
   ByVal nSize As Long) As Long
   
Public Function ExpandEnvironmentVariables(ByVal Path As String) As String
    Dim Length As Long
    Dim strOutput As String

    strOutput = Space$(255)
    Length = ExpandEnvironmentStrings(Path, strOutput, Len(strOutput))
    
    ExpandEnvironmentVariables = Left$(strOutput, Length - 1)
End Function

Public Function AddSlash(ByRef FilePath As String, Optional ByVal Character As String = "\", Optional ByVal TreatAlwaysAsAFolder As Boolean) As String
    AddSlash = mdlString.ApiAddSlash(FilePath, Character, TreatAlwaysAsAFolder)
End Function

'Public Function AddSlash2(ByVal FilePath As String) As String
'    AddSlash2 = mdlString.ApiAddSlash(FilePath, "\", True)
'End Function

Public Function RemoveSlash(ByVal FilePath As String) As String 'new
    If Right$(FilePath, 1) = "\" Then
        RemoveSlash = Left$(FilePath, InStrRev(FilePath, "\") - 1)
    Else
        RemoveSlash = FilePath
    End If
End Function


Public Function GetFolderPathEx(ByVal Path As String, Optional ByVal Directories As Long = -1) As String
    GetFolderPathEx = ApiGetFolderPathEx(Path, Directories)
End Function

Public Function GetShortPath(ByVal FilePath As String) As String
    GetShortPath = mdlIO.GetShortPath(FilePath)
End Function

Public Function GetFileExtension(ByVal FilePath As String, Optional ByVal IncludeDot As Boolean = True, Optional ByVal MustBeOneOfTheseExtensions As String) As String
    GetFileExtension = mdlString.ApiGetFileExtension(FilePath, IncludeDot, MustBeOneOfTheseExtensions)
End Function

Public Function GetFileBasename(ByVal FilePath As String) As String
    GetFileBasename = mdlString.ApiGetFileBasename(FilePath)
End Function

Public Function GetFileName( _
        ByVal FilePath As String, _
        Optional ByVal Character As String = "\", _
        Optional ByVal WithoutExtension As Boolean _
        ) As String
    GetFileName = mdlString.ApiGetFileName(FilePath, Character, WithoutExtension)
End Function

Public Function GetFilePath(ByVal FilePath As String, Optional ByVal Character As String = "\", Optional ByVal CharacterAmountPos As Long = 1) As String
    GetFilePath = mdlString.ApiGetFilePath(FilePath, Character, CharacterAmountPos)
End Function

Public Function GetSysDir() As String
    GetSysDir = mdlIO.ApiGetSysDir()
End Function

Public Function GetDirectory(ByVal CSIDL As SpecialFolder) As String
    GetDirectory = mdlIO.ApiGetDirectory(CSIDL)
End Function

Public Function GetTempDir() As String
    GetTempDir = mdlIO.ApiGetTempDir()
End Function

Public Function GetWinDir() As String
    GetWinDir = mdlIO.ApiGetWinDir()
End Function

Public Function IsDirectory(ByVal Path As String) As Boolean
    IsDirectory = mdlString.ApiIsFolder(Path)
End Function

Public Function AppedFileNameSuffix(ByVal FilePath As String, ByVal Suffix As String) As String  '2015-01-21
    Dim FileName As String
    Dim BasePath As String
    Dim FileBaseName As String
    Dim FileExtension As String
    
    FileName = mdlString.ApiGetFileName(FilePath)
    BasePath = mdlString.ApiGetFilePath(FilePath)
    FileBaseName = mdlString.ApiGetFileBasename(FileName)
    FileExtension = mdlString.ApiGetFileExtension(FileName, True)

    AppedFileNameSuffix = PathCombine(BasePath, FileBaseName & Suffix & FileExtension)
End Function

Public Function IncrementFileName(ByVal FilePath As String, _
        Optional ByVal IncrementSeparator As String = "_") As String '2015-01-21
    Dim FileName As String
    Dim BasePath As String
    Dim FileBaseName As String
    Dim FileExtension As String
    Dim i As Integer
    Dim NewPath As String
    
    FileName = mdlString.ApiGetFileName(FilePath)
    BasePath = mdlString.ApiGetFilePath(FilePath)
    FileBaseName = mdlString.ApiGetFileBasename(FileName)
    FileExtension = mdlString.ApiGetFileExtension(FileName, True)
    
    Do
        i = i + 1
        
        NewPath = PathCombine(BasePath, FileBaseName & IncrementSeparator & i & FileExtension)
    Loop While mdlIO.SafeFileExists(NewPath)
    
    IncrementFileName = NewPath
End Function

Public Function PathCombine(ParamArray Paths() As Variant) As String '2015-01-20
    PathCombine = mdlPath.PathCombine(Paths)
End Function

Public Function AddDirectorySeparator(ByRef FilePath As String, Optional ByVal Character As String = "\", _
        Optional ByVal TreatAlwaysAsAFolder As Boolean) As String '2015-01-21
    AddDirectorySeparator = mdlString.ApiAddSlash(FilePath, Character, TreatAlwaysAsAFolder)
End Function

Public Function RemoveDirectorySeparator(ByVal FilePath As String) As String '2015-01-21
    If Right$(FilePath, 1) = "\" Then
        RemoveDirectorySeparator = Left$(FilePath, InStrRev(FilePath, "\") - 1)
    Else
        RemoveDirectorySeparator = FilePath
    End If
End Function
